/* =================================================================================
 *  mainAlberi.c
 * =================================================================================
 *  Programma di test per esercizi su alberi binari
 *  Authors:     Emanuela Fachini (fachini@di.uniroma1.it)
 *               Irene Finocchi   (finocchi@di.uniroma1.it)
 *               Chiara Petrioli  (petrioli@di.uniroma1.it)
 *  Last change: 2 Aprile 2005
 *  Changed by:  Irene Finocchi
*/

#include "alberi.h"

int main(void) {

	TreePtr TT;
	int numeroNodi, altezza, livelloFogliaSin;

    printf("Costruzione di un albero binario inserito da input.\n\n") ;
    printf("Gli interi contenuti nei nodi vanno inseriti in preordine.\n") ;
    printf("L'input consiste di coppie <i,j> dove\n") ;
    printf("   i rappresenta il valore intero del nodo\n") ;
    printf("   j vale: 0 se il nodo non ha figli, -1 se ha solo figlio sinistro\n") ;
    printf("           1 se ha solo figlio destro, 2 se ha entrambi i figli\n\n") ;

    printf("Inserisci ora la sequenza di coppie i j, terminando con un ritorno a capo\n") ;
    printf("(ad esempio 10 2 8 -1 3 0 4 2 2 0 5 2 6 0 7 0):\n") ;

	TT=creaalbero();

	printf("\nVisita inorder dell'albero:\n");
	stampaAlberoInorder(TT);

	printf("\n\n");

	printf("Stampa indentata dell'albero \n\n");
	stampaIndentata(TT,0);

	printf("\n");

    /* Calcolo del numero di nodi */
	printf("Numero nodi (versione funzionale): %d \n", numNodi(TT));
    numeroNodi=0;
    numNodi2(TT, &numeroNodi);
	printf("Numero nodi (versione procedurale): %d \n\n", numeroNodi);

    /* Calcolo dell'altezza */
	printf("Altezza (versione funzionale): %d \n", alt(TT));
    altezza=-1;
    alt2(TT, &altezza);
	printf("Altezza (versione procedurale): %d \n\n", altezza);

    /* Calcolo della foglia piu' a sinistra */
	printf("Livello foglia piu' a sinistra (versione funzionale): %d \n",livFoSin(TT));
    livelloFogliaSin=-1;
    livFoSin2(TT, &livelloFogliaSin);
	printf("Livello foglia piu' a sinistra (versione procedurale): %d \n\n", livelloFogliaSin);

    /* Calcolo del numero di foglie */
	printf("Il numero di foglie dell'albero e': %d \n\n", numfoglie(TT));

	printf("Sayonara!\n");

	return 1;
}





